/**
	Main JEmuX class.
*/


/**
	Classes tipical order:
	1) JemuxLogin
	2) JemuxUser
	3) JemuxShell
*/


import java.io.*;
import java.util.*;
import java.security.*;


public class JEmuX
{
	public static void main(String args[]) throws NoSuchAlgorithmException
	{
		boolean ok = true;

		while(ok)
		{
			ok = false;

		/*****************************************
			FIRST STEP
			----------
			Login procedure.
			-
			If user correctly logs in, this procedure moves to the second step.
		*****************************************/

			JemuxLogin login = new JemuxLogin();
			String hostname = login.getHostName();

			try {
				do {
					login.getUandP();
				} while (login.gotAccess()==false);
			} catch (NoSuchAlgorithmException nsae) {
				System.err.println(nsae);
				System.exit(-1);
			} catch (IOException ioe) {
				System.err.println(ioe);
				System.exit(-1);
			}


		/*****************************************
			SECOND STEP
			-----------
			User's setup procedure.
			-
			User got recognized and this procedure sets him up.
		*****************************************/

			JemuxUser user = login.getGoodUser();


		/*****************************************
			THIRD STEP
			----------
			Shell procedure.
			-
			User got authenticated and this procedure returns him a valid shell.
		*****************************************/

			JemuxShell shell = new JemuxShell(user, hostname);

			while(!shell.getExitStatus())
			{
				shell.getCmdLineArguments();
				if (shell.getCmdLineText()==null)
				{
					shell.getShellPrompt();
				}
				JemuxShellParser parser = new JemuxShellParser(shell.getCmdLineText());
				JemuxCommand command = new JemuxCommand(parser.getCommand(), user);
				shell.exitStatus = !command.currentStatus;
			}

			ok = shell.exitStatus;
		}
	}
}
