import java.util.*;
import java.security.*;


public class JemuxCommand
{
	public JemuxCommand(String[] tokens, JemuxUser user) throws NoSuchAlgorithmException
	{
		int n = tokens.length;
		this.user = user;
		program = tokens[0];
		args = new String[n-1];

		for (int i=1; i<n; i++)
		{
			args[i-1] = tokens[i];
		}
		init();
	}

	public void init() throws NoSuchAlgorithmException
	{
		if (program!=null)
		{
			if (program.equals("adduser"))
				new JemuxAdduser(args);
			else if (program.equals("cd"))
        		new JemuxCd(args, user);
			else if (program.equals("clear"))
				System.out.print("\033[2J"); // ugly!
			else if (program.equals("date"))
				new JemuxDate(args);
			else if (program.equals("echo"))
				new JemuxEcho(args);
			else if (program.equals("exit")||program.equals("logout"))
			{
				System.out.println("Goodbye, "+user.getUserName()+"!");
				currentStatus = false;
			}
			else if (program.equals("halt"))
			{
				System.out.println("System halted.");
				System.exit(0);
			}
			else if (program.equals("help"))
				new JemuxHelp(args);
			else if (program.equals("hostname"))
				new JemuxHostName(args);
			else if (program.equals("id"))
				new JemuxId(args, user);
			else if (program.equals("ls"))
        		new JemuxLs(args, user);
			else if (program.equals("mkdir"))
        		new JemuxMkdir(args, user);
			else if (program.equals("pwd"))
        		new JemuxPwd(args, user);
			else if (program.equals("touch"))
       			new JemuxTouch(args, user);
			else if (program.equals("uname"))
				new JemuxUname(args);
			else if (program.equals("whoami"))
				new JemuxWhoami(args, user);
			else
				System.err.println(program+": command not found");
		}
	}

	private JemuxUser user;
	private String program;
	private String[] args;
	public boolean currentStatus = true;
}
