public class JemuxHelp implements JemuxCommandInterface
{
	public JemuxHelp(String[] args)
	{
		this.args = args;
		init();
	}

	public void init()
	{
		if (args.length==0)
		{
			System.out.println();
  			System.out.println("*** JEmuX commands listing ***");
			System.out.println();
			System.out.println("  adduser    -   adds a new user to the system");
			System.out.println("  cd         -   moves into a new directory");
			System.out.println("  date       -   prints current date and time");
			System.out.println("  echo       -   echoes a given text string");
			System.out.println("  exit       -   ends user's session");
			System.out.println("  halt       -   halts the system");
			System.out.println("  help       -   help about JEmuX commands");
			System.out.println("  hostname   -   prints the hostname");
			System.out.println("  id         -   prints a user's UID and GID");
			System.out.println("  ls         -   lists files in a directory");
			System.out.println("  logout     -   ends user's session");
			System.out.println("  mkdir      -   creates a new directory");
			System.out.println("  pwd        -   prints user's current directory");
			System.out.println("  touch      -   creates an empty file");
			System.out.println("  uname      -   prints system information");
			System.out.println("  whoami     -   prints user's login name");
			System.out.println();
			System.out.println("To get further information about a command, please type:");
			System.out.println("  <command> --help");
		}
		else
		{
			if(args[0].equals("--help"))
			{
				System.out.println(getHelp());
			}
			else
			{
				System.err.println("help: wrong option!");
			}
		}
	}

	public String getHelp()
	{
		return "[help] - this command prints system commands help\n" +
			"usage:   help";
	}

	private String[] args;
}
