import java.io.*;


public class JemuxHostName implements JemuxCommandInterface
{
	public JemuxHostName(String[] args)
	{
		file = new JemuxFileHandler();
		this.args = args;
		init();
	}

	public void init()
	{
		String hostname = "";

		try {
			hostname = file.getFileContent("hostname")[0];
		} catch (IOException ioe) {
			System.out.println(ioe);
			System.exit(-1);
		}

		if (args.length==0)
			System.out.println(hostname);
		else if (args[0].equals("--help"))
			System.out.println(getHelp());
		else
			System.err.println("hostname: wrong option!");
	}

	public String getHelp()
	{
		return "[hostname] - this command prints the hostname\n" +
			"usage:   hostname";
	}

	private String[] args;
	private JemuxFileHandler file;
}
