import java.io.*;


public class JemuxUser
{
	public JemuxUser(String un, String gr, int uid, int gid, String sh, String hd)
	{
		userName = un;
		userGroup = gr;
		userUID = uid;
		userGID = gid;
		userShell = sh;
		userHomeDir = hd;
		userCurrDir = userHomeDir; // current directory is home directory
		userPrevDir = userHomeDir; // previous directory is home directory
	}

	public String getUserName()
	{
		return userName;
	}

	public String getUserGroup()
	{
		return userGroup;
	}

	public int getUID()
	{
		return userUID;
	}

	public int getGID()
	{
		return userGID;
	}

	public String getUserShell()
	{
		return userShell;
	}

	public String getUserHomeDir()
	{
		return userHomeDir;
	}

	public String getUserCurrDir()
	{
		return userCurrDir;
	}

	public void setUserCurrDir(String currdir)
	{
		setUserPrevDir(userCurrDir);
		userCurrDir = currdir;
	}

	public String getUserPrevDir()
	{
		return userPrevDir;
	}

	private void setUserPrevDir(String prevdir)
	{
		userPrevDir = prevdir;
	}

	public String getRealPath()
	{
		return realPath;
	}



	/*** new method to parse "pathname+filename" before read/write/use any dir/file ***/

	/* cases of possible path (here, foo is a directory):
		foo				(means foo is in the current directory)
		./foo			(such as above)
		tmp/foo			(means foo is in "tmp", which is in the current directory)
		/foo			(means foo is in the root directory)
		../foo			(means foo is in the parent of current directory)
		../../../foo	(means foo is three levels down the current directory)
	*/

	public String parsePath(String filename) throws IOException
	{
		String fullPath = getRealPath() + getUserCurrDir() + "/" + filename; /* real path on main system */
		File tempFile = new File(fullPath);

		if ((!(tempFile.getCanonicalPath().contains(getRealPath())))||(filename.charAt(0)=='/'))
		{
			fullPath = getRealPath() + ((tempFile.getName().charAt(0)=='/')?"":"/") + tempFile.getName();
		}
		else if (filename.charAt(0)=='~')
		{
			fullPath = getRealPath() + filename.replace("~", getUserHomeDir());
			/* add support for "~username" (ex: "touch ~guest/foo") */
		}

		return fullPath;
	}


	String userName;
	String userGroup;
	int userUID;
	int userGID;
	String userShell;
	String userHomeDir; /* user's home directory */
	String userCurrDir; /* user's current directory (user is "phisically" in)*/
	String userPrevDir; /* user's previous directory (previous to user's *current* directory */


	/* realPath is JEmuX's fake root directory */
	private static final String realPath = new File("").getAbsolutePath();		/* EX:    /home/pippo/java/JEmuX     */
}
