import java.io.*;				/*** add support for multiple dirs and recursion!!!!!!!!!!!!!!!!! ***/


public class JemuxMkdir implements JemuxCommandInterface
{
	public JemuxMkdir(String[] args, JemuxUser user)
	{
		this.args = args;
		this.user = user;
		init();
	}

	public void init()
	{
		if (args.length!=0)
		{
			if (args[0].equals("--help"))
			{
				System.out.println(getHelp());
			}
			else
			{
				for (int i=0; i<args.length; i++)
				{
					try {
    	    			String dirname = user.parsePath(args[i]);
						File dir = new File(dirname);
						dir.mkdir();
					} catch (IOException ioe) {
						System.err.println(ioe);
					}
				}
			}
		}
		else
		{
			System.err.println("mkdir: too few arguments\nTry 'mkdir --help' for more information.");
		}
	}

	public String getHelp()
	{
		return "[mkdir] - creates a new directory\n" +
			"usage:   mkdir <directory>";
	}

	private String[] args;
	private JemuxUser user;
}
