import java.io.*;				/*** add support for multiple files!!!!!!!!!!!!!!!!! ***/


public class JemuxTouch implements JemuxCommandInterface
{
	public JemuxTouch(String[] args, JemuxUser user)
	{
		this.args = args;
		this.user = user;
		init();
	}

	public void init()
	{
		if (args.length!=0)
		{
			if (args[0].equals("--help"))
			{
				System.out.println(getHelp());
			}
			else
			{
				for (int i=0; i<args.length; i++)
				{
					try {
    	    			String filename = user.parsePath(args[i]);
						File file = new File(filename);
        				file.createNewFile();
					} catch (IOException ioe) {
						System.err.println(ioe);
					}
				}
			}
		}
		else
		{
			System.err.println("touch: file arguments missing\nTry 'touch --help' for more information.");
		}
	}

	public String getHelp()
	{
		return "[touch] - creates an empty file (size is 0 bytes)\n" +
			"usage:   touch <filename>";
	}

	private String[] args;
	private JemuxUser user;
}
