import java.io.*;
import java.security.*;


public class JemuxUname implements JemuxCommandInterface
{
	public JemuxUname(String[] args) throws NoSuchAlgorithmException
	{
		file = new JemuxFileHandler();
		this.args = args;
		init();
	}

	public void init() throws NoSuchAlgorithmException
	{
		String OS_name;
		String OS_version;
		String OS_architecture;
		String VM_name;
		String VM_version;
		String hostname = "";

		try {
			hostname = file.getFileContent("etc/hostname")[0];
		} catch (IOException ioe) {
			System.out.println(ioe);
			System.exit(-1);
		}
		OS_name = "JEmuX (on "+System.getProperty("os.name")+")";
		OS_version = System.getProperty("os.version");
		OS_architecture = System.getProperty("os.arch");
		VM_name = System.getProperty("java.vm.name");
		VM_version = System.getProperty("java.vm.version");

		if (args.length==0)
		{
			System.out.println(OS_name);
		}
		else
		{
			if (args[0].equals("--help"))
				System.out.println(getHelp());
			else if (args[0].equals("-a"))
				System.out.println(OS_name+" "+hostname+" "+OS_version+" ["+VM_name+" "+VM_version+"] "+OS_architecture);
			else if (args[0].equals("-r"))
				System.out.println(OS_version);
			else
				System.err.println("uname: wrong option!");
		}
	}

	public String getHelp()
	{
		return "[uname] - this command prints some information about the system\n" +
			"usage:   uname [options]\n" +
			"    options:\n" +
			"        -a			prints whole system information\n" +
			"        -r			prints OS version only";
	}

	private String[] args;
	private JemuxFileHandler file;
}
